import sys

from ._base import ALL_COMPLETED as ALL_COMPLETED
from ._base import FIRST_COMPLETED as FIRST_COMPLETED
from ._base import FIRST_EXCEPTION as FIRST_EXCEPTION
from ._base import BrokenExecutor as BrokenExecutor
from ._base import CancelledError as CancelledError
from ._base import Executor as Executor
from ._base import Future as Future
from ._base import TimeoutError as TimeoutError
from ._base import as_completed as as_completed
from ._base import wait as wait
from .process import ProcessPoolExecutor as ProcessPoolExecutor
from .thread import ThreadPoolExecutor as ThreadPoolExecutor

if sys.version_info >= (3, 8):
    from ._base import InvalidStateError as InvalidStateError

__all__ = (
    "FIRST_COMPLETED",
    "FIRST_EXCEPTION",
    "ALL_COMPLETED",
    "CancelledError",
    "TimeoutError",
    "BrokenExecutor",
    "Future",
    "Executor",
    "wait",
    "as_completed",
    "ProcessPoolExecutor",
    "ThreadPoolExecutor",
)

def __dir__() -> tuple[str, ...]: ...
