import sys

from .case import FunctionTestCase as FunctionTestCase
from .case import SkipTest as SkipTest
from .case import TestCase as TestCase
from .case import expectedFailure as expectedFailure
from .case import skip as skip
from .case import skipIf as skipIf
from .case import skipUnless as skipUnless
from .loader import TestLoader as TestLoader
from .loader import defaultTestLoader as defaultTestLoader
from .loader import findTestCases as findTestCases
from .loader import getTestCaseNames as getTestCaseNames
from .loader import makeSuite as makeSuite
from .main import TestProgram as TestProgram
from .main import main as main
from .result import TestResult as TestResult
from .runner import TextTestResult as TextTestResult
from .runner import TextTestRunner as TextTestRunner
from .signals import installHandler as installHandler
from .signals import registerResult as registerResult
from .signals import removeHandler as removeHandler
from .signals import removeResult as removeResult
from .suite import BaseTestSuite as BaseTestSuite
from .suite import TestSuite as TestSuite

if sys.version_info >= (3, 8):
    from unittest.async_case import *

    from .case import addModuleCleanup as addModuleCleanup

if sys.version_info >= (3, 11):
    from .case import doModuleCleanups as doModuleCleanups
    from .case import enterModuleContext as enterModuleContext

__all__ = [
    "TestResult",
    "TestCase",
    "TestSuite",
    "TextTestRunner",
    "TestLoader",
    "FunctionTestCase",
    "main",
    "defaultTestLoader",
    "SkipTest",
    "skip",
    "skipIf",
    "skipUnless",
    "expectedFailure",
    "TextTestResult",
    "installHandler",
    "registerResult",
    "removeResult",
    "removeHandler",
    "getTestCaseNames",
    "makeSuite",
    "findTestCases",
]

if sys.version_info >= (3, 8):
    __all__ += ["addModuleCleanup", "IsolatedAsyncioTestCase"]

if sys.version_info >= (3, 11):
    __all__ += ["enterModuleContext", "doModuleCleanups"]

def load_tests(loader: TestLoader, tests: TestSuite, pattern: str | None) -> TestSuite: ...
def __dir__() -> set[str]: ...
